import sys
from BeautifulSoup import BeautifulSoup
import re
import urllib
import urllib2
import datetime
from Channel import Channel
import string
import cPickle as pickle
import preferences
import pprint
import time
import math
from urllib import urlencode
import time

def getPage(url):
	try:
		req_headers = {
		'User-Agent': 'Mozilla/4.0 (compatible; MSIE 5.5; Windows NT)',
		}
		page = urllib2.Request(url, None, req_headers)
		opener = urllib2.build_opener()
		text = opener.open(page)
	except:
		return None
	else:
		out = text.read()
		opener.close()
		return out
	
def getListing(duration,when=0):
	pref = readPreferences()
	if(pref == 0):
		print "Preferences are not created, choose a zip, then a lineup"
	startime = str(time.time()).split(".")[0]
	startime = int(startime)
	startime = startime + (when*duration*3600)
	if int(pref.getCountry()) == 1:
		countryUrlCode = "ca."
		countryCode = "ca"
	else:
		countryCode = "us"
		countryUrlCode = ""
		
	for k in range(duration):
		nice = 0
		urltoopen = "http://%stv.yahoo.com/grid?zip=%s&lineup=%s&genres=&dur=0&starttime=%s&.intl=%s" % (countryUrlCode,pref.getZip(),pref.getLineup(),startime,countryCode)
		text = getPage(urltoopen)
		while not text or len(text) < 1024:
			if nice<15:
				time.sleep(1)
				text = getPage(urltoopen)
				nice += 1
			if nice==15:
				return -1
		if not text:
			return -1
		allChannelsOut,listings = pruner(text,pref.getFavorites())
		startime += 3600
		writeListing(listings,k)
	filename = "allchannels.txt"
	filer = open(filename,"w")
	filer.write(allChannelsOut)
	filer.close()
	return 0
	

##
## big pruner
##
def pruner(text,channel):
	pref = readPreferences()
	oldChannel = None
	allChannels = []
	sortingChannels = []
	allChannelsOut = ""
	oldChannelName = ""
	oldChannelNumber = ""
	
	counter = 0
	
	pattern = re.compile(r"""<td colspan=[\"]?([0-9]*)[\"]? [^\>]*>[^<]*<font size=\"-1\">[^<]*<A HRef=\"([^\"]*)\">([^<]*)</A>""")
	matched = pattern.findall(text)
	
	pat_display = re.compile(r'<td align="center" width="[^\"]*" colspan="([0-9]*)">[^<]*<font [^>]*>[^<]*<b>([^<]*)</b>[^<]*</font>[^<]*</td>')
	display = pat_display.findall(text)
	displayTimes =	[ display[0][1],display[1][1] ]
	displayWidth = display[0][0]
	
	for channels in matched:
		#brokenName = false;
		pat_chname = re.compile(r"""chname=([^\+]*)\+([0-9]*)""")
		chname = pat_chname.search(channels[1])
		pat_progutn = re.compile(r'progutn=([0-9]*)&')
		progutn = pat_progutn.search(channels[1])
		if not chname:
			pat_chname = re.compile(r"""chname=([^\&]*)&""")
			chname = pat_chname.search(channels[1])
			channelName = urllib.unquote(chname.groups()[0])
			channelNumber = "N/A"
			#brokenName = true;
		else:
			channelName = urllib.unquote(chname.groups()[0])
			channelNumber = chname.groups()[1]
		
		if oldChannelName != channelName or oldChannelNumber != channelNumber:
			sortingChannel = Channel()
			sortingChannel.setNumber(channelNumber)
			sortingChannel.name = channelName
			sortingChannels.append(sortingChannel)
			#allChannelsOut += "%s %s\n" % (channelName, channelNumber)
			oldChannelName = channelName
			oldChannelNumber = channelNumber
		#print "%s %s vs %s %s" % (channelName, channelNumber, oldChannelName, oldChannelNumber)
		for favorites in channel:
			
			if favorites[1] == channelName and favorites[0] == channelNumber:
				#print "%s == %s and %s == %s" % (favorites[1],channelName,favorites[0],channelNumber)
				showSize = channels[0]
				showUrl = re.sub('\n','',channels[1])
				showTime = datetime.datetime.fromtimestamp(string.atof(progutn.groups()[0]))
				urlEncoder = urllib.urlencode({"s" : showUrl})
				showUrl = "http://tv.yahoo.com%s" % urlEncoder[2:]
				showName = channels[2]
				
				if oldChannel and ( oldChannel.getName() == channelName and oldChannel.getNumber() == channelNumber ):
					oldChannel.addShow(showName,showTime,showSize,showUrl)
				else:
					oldChannel = Channel()
					oldChannel.addChannel(channelName)
					oldChannel.setNumber(channelNumber)
					oldChannel.setTime(displayTimes)
					oldChannel.setWidth(displayWidth)
					oldChannel.addShow(showName,showTime,showSize,showUrl)
					allChannels.append(oldChannel)
	
	allChannels.sort()
	sortingChannels.sort()
	allChannelsOut = sortAllChannelsForFavorites(sortingChannels)
	
	return allChannelsOut, allChannels

def sortAllChannelsForFavorites(ac):
	allChannelsOut = ""
	#print ac
	for chan in ac:
		#print chan
		allChannelsOut += "%s %s\n" % (chan.getName(),chan.getNumber())
	return allChannelsOut

def createAllFavoritesList():
	pref =readPreferences()
	channel = pref.getFavorites()
	output = ""
	counter = 0
	checked_counter = 0
	oldChannel = ""
	allchan = open("allchannels.txt","r")
	allchans = allchan.read()
	pat_chan = re.compile(r"""([^ ]*) ([^\n]*)\n""")
	chans = pat_chan.findall(allchans)
	clearFavorites()
	for channels in chans:
		channelName = channels[0]
		channelNumber = channels[1]
		checker = ""
		if oldChannel != channelName:
			pref.setFavorite(channelNumber,channelName)
			channelDisplay = channelNumber
			if channelNumber == "N/A":
				channelDisplay = ""
			checker = "checked"
			output += """<input type="checkbox" name="%s" value="%s" %s onClick="setFavorite(this);"><span class="favorites_text">%s %s</span><br>\n""" % (re.sub('&','\&',urllib.unquote(channelName)), channelNumber,checker,urllib.unquote(channelName),channelDisplay)
			counter += 1
			checked_counter += 1
			
	writeChannelList(output)
	pref.setNumOfChannels(counter)
	writePreferences(pref)
	print checked_counter
	
def createFavoritesList():
	pref =readPreferences()
	channel = pref.getFavorites()
	output = ""
	counter = 0
	checked_counter = 0
	oldChannel = ""
	allchan = open("allchannels.txt","r")
	allchans = allchan.read()
	pat_chan = re.compile(r"""([^ ]*) ([^\n]*)\n""")
	chans = pat_chan.findall(allchans)
	for channels in chans:
		channelName = channels[0]
		channelNumber = channels[1]
		checker = ""
		for favorites in channel:
			if favorites[1] == channelName and favorites[0] == channelNumber:
				checker = "checked"
				checked_counter += 1
		channelDisplay = channelNumber
		if channelNumber == "N/A":
			channelDisplay = ""
		
		output += """<input type="checkbox" name="%s" value="%s" %s onClick="setFavorite(this);"><span class="favorites_text">%s %s</span><br>\n""" % (re.sub('&','\&',urllib.unquote(channelName)), channelNumber,checker,urllib.unquote(channelName),channelDisplay)
		counter += 1
	writeChannelList(output)
	pref.setNumOfChannels(counter)
	writePreferences(pref)
	print checked_counter
	

def writeChannelList(output):
	filename ="channel_list.html"
	cList = open(filename,"w")
	cList.write(output)
	cList.close()

##
## favorites
##
def setFavorite(num,name):
	pref = readPreferences()
	pref.setFavorite(num,name)
	writePreferences(pref)
	print len(pref.getFavorites())
	
def clearFavorites():
	pref = readPreferences()
	pref.clearFavorites()
	writePreferences(pref)
			
def writeListing(listing,which):
	filename = "listings%s.pk" % which
	listFile = open(filename,"w")
	pickle.dump(listing,listFile)
	listFile.close()
				
def readListing(which):
	try:
		filename = "listings%s.pk" % which
		listFile = file(filename,"r")
		listings = pickle.load(listFile)
		listFile.close()
		return listings
	except:
		return 0

def getSmallListing():
	datetime.datetime()
		
def getLineup(zip):
	nice = 0
	pref = readPreferences()
	pref.setZip(zip)
	preferenceLineup = pref.getLineup()
	
	writePreferences(pref)
	if int(pref.getCountry()) == 1:
		countryUrlCode = "ca."
		countryCode = "ca"
	else:
		countryCode = "us"
		countryUrlCode = ""
	
	urltoopen = 'http://%stv.yahoo.com/lineup?zip=%s' % (countryUrlCode, zip)
	text = getPage(urltoopen)
	while not text:
		if nice<10:
			time.sleep(1)
			text = getPage(urltoopen)
			nice += 1
		if nice==10:
			return -1
	if not text:
		return -1
	soup = BeautifulSoup(text)
	output = """
	<span class="ziptext">Provider</span> <select name='menu' onchange='lineup(this);' style='width:70px;font-size:10px;font:'Futura-CondensedMedium';'>
		"""
	sel = soup('select', { 'name' : 'lineup' })
	for lineup in range(len(sel)):
		selected = sel[lineup]
		listing = selected.parent.parent.parent.b.string
		listing = listing[:len(listing)-9]
		output += """<option value="">%s</option>""" % listing
		for options in selected('option'):
			val = options['value']
			contents = options.string
			if val == preferenceLineup:
				selected = "selected"
			else:
				selected = ""
			output = output + """
			<option value='%s' %s>%s</option>""" % (val, selected, contents)
		output += "<option value=""></option>"
	output = output +"""</select>"""
	
	outProviderList = open("providers.html","w")
	outProviderList.write(output)
	outProviderList.close()
	return 0

def findChannel(num):
	counter = 0
	list = readListing()
	for chan in list:
		name = chan.getName()
		pattern = re.compile(r'[0-9a-zA-Z]* ([0-9]*)')
		matched = pattern.search(name)
		chan_num = int(matched.groups()[0])
		#print "CN: %s" % chan_num
		if chan_num==num:
			return counter
		counter += 1

def writePreferences(pref):
	try:
		prefFile = file("preferences.pk","w")
		pickle.dump(pref,prefFile)
		prefFile.close()
		return 1
	except:
		return 0

def readPreferences():
	try:
		prefFile = file("preferences.pk","r")
		pref = pickle.load(prefFile)
		prefFile.close()
		return pref
	except:
		pref = preferences.Preferences()
		writePreferences(pref)
		return pref
	
def fixMinute(minute):
	if minute == 0:
		return "%s0" % minute
	return minute

def fixHour(hour):
	if hour > 12 and hour != 0:
		return hour-12
	if hour == 0:
		return 12
	return hour

def fixTHour(hour,startampm):
	if startampm == "pm":
		if hour==12:
			return hour
		else:
			return hour+12
	if startampm == "am":
		if hour==12:
			return 24
	
def round5(num):
	if num<.5:
		return .5
	if num>.5 and num<1:
		return 1
	if num>1 and num<1.5:
		return 1.5
	if num>1.5 and num < 2:
		return 2
	return num
	
def wrapListings(c,dur):
	rowcount = 0
	timecounter = 0
	# div separators
	topper = 81
	ctop = 0
	cinc = 30
	stop = 0
	sinc = 31
	sleft = 41
	sleftinc = 96
	maxwidth = 0
	times = c[0].getTime()
	pattern = re.compile(r'([0-9]*):[0-9]*([a-z][a-z])')
	match = pattern.search(times[0])
	starthour = int(match.groups()[0])
	startampm = match.groups()[1]
	
	match = pattern.search(times[1])
	endhour = int(match.groups()[0])
	endampm = match.groups()[1]
	
	tempwidth = c[0].getWidth()
	start = times[0]
	header1 = "%s" % (start)
	if startampm == endampm:
		header1 = header1[0:len(header1)-2]
	header1 = string.upper(header1)						
	start = times[1]   
	header2 = "%s" % (start)
	header2 = string.upper(header2)
	channelHeadOutput = ""
	channelOutput = ""
	
	output = """<div id="time1" style="position:absolute; left:74px; top:40px; width:96px; height:20px; z-index:2" class="time">%s</div><div id="time2" style="position:absolute; left:172px; top:40px; width:96px; height:20px; z-index:2" class="time">%s</div>""" % (header1,header2)
	for i in c:
		channel = i
		name = channel.getName()
		num = channel.getNumber()
		href = None
		#channelOutput = ""
		#channelHeadOutput = ""
		channelDisplay = num
		if num=="N/A":
			channelDisplay = """&nbsp;&nbsp;%s""" % name[:7]
		else:
			channelDisplay = """<span class="chan_num">%s</span><br>&nbsp;&nbsp;%s""" % (num,name[:7])
			
		channelHeadOutput = channelHeadOutput+"""<div id="chan1" style="position:absolute; left:0px; top:%spx; width:38px; height:35px; z-index:1" class="chan_text">%s</div>""" % (ctop,channelDisplay);
		for a in channel.getChannel():
			timecounter += 1
			title = a[0]
			time = a[1]
			duration = a[2]
			href = a[3]
			colspan = float(duration)
			#print colspan
			width = float(duration)/tempwidth
			width = round5(width)
				
			#if len(title)>11 and width<2:
			#	 print title
			#	 title = "%s..."%(title[:11])
			#	 print title
			append = ""
			
			
			maxwidth += colspan
			display_width = 96*width
			if width == .5:
				#print "Width is 15minutes"
				channelOutput = channelOutput + """<div id="show_1" style="position:absolute; left:%spx; top:%spx; width:%spx; height:30px; z-index:1;overflow:hidden;text-overflow:ellipsis;border-bottom:1px solid #3F50A0;border-right:1px solid #3F50A0;"><div class="show_text" nowrap><span  align="left" id="launcher" onClick="launch('%s');" nowrap>%s%s</span></div></div>""" % (sleft,stop,width*96,href,append,title)
			
			if width == 1 or ( width>1 and sleft>37 ):
				channelOutput = channelOutput + """<div id="show_2" style="position:absolute; left:%spx; top:%spx; width:%spx; height:30px; z-index:4;overflow:hidden;text-overflow:ellipsis;border-bottom:1px solid #3F50A0;border-right:1px solid #3F50A0;"><div class="show_text" nowrap><span align="left" id="launcher" onClick="launch('%s');" nowrap>%s%s</span></div></div>""" % (sleft,stop,display_width,href,append,title)
				
			elif width>1 and sleft==37:
				if width > 1 and width < 2:
					channelOutput = channelOutput + """<div id="show_3" style="position:absolute; left:41px; top:%spx; width:%spx; height:30px; z-index:4;overflow:hidden;text-overflow:ellipsis;border-bottom:1px solid #3F50A0;border-right:1px solid #3F50A0;"><div class="show_text" align="left" nowrap><span align="left"	 id="launcher" onClick="launch('%s');" nowrap>%s%s</span></div></div>""" % (stop,display_width,href,append,title)
				else:
					channelOutput = channelOutput + """<div id="show_4" style="position:absolute; left:41px; top:%spx; width:%spx; height:30px; z-index:4;overflow:hidden;text-overflow:ellipsis;border-bottom:1px solid #3F50A0;border-right:1px solid #3F50A0;"><div class="show_text" align="left" nowrap><span align="left"	 id="launcher" onClick="launch('%s');" nowrap>%s%s</span></div></div>""" % (stop,display_width,href,append,title)

			
			if maxwidth==tempwidth*2:
				stop += sinc
			 
			sleft += (sleftinc*width)
			#if width == .5:
			#	 sleft += (sleftinc/2)
			#elif width == 1.5:
			#	 sleft += sleftinc
		#writeChannel(rowcount,channelOutput)
		#writeChannelHead(rowcount,channelHeadOutput)
		timecounter = 0
		maxwidth = 0
		rowcount += 1
		ctop += sinc
		sleft = 41
	writeChannel(channelOutput)
	writeChannelHead(channelHeadOutput)
	
	print output

def writeChannelHead(o):
	filename = "channel_head.html"
	chanFile = open(filename,"w")
	chanFile.write(o)
	chanFile.close()
			
def writeChannel(o):
	filename = "channel.html"
	chanFile = open(filename,"w")
	chanFile.write(o)
	chanFile.close()
	
def numberOfFavorites():
	pref = readPreferences()
	print len(pref.getFavorites())
	
def printListings(c,bottom=0,top=0,dur=0):

	if bottom!=0 and top == 0:
		c = c[bottom:]
	if bottom==0 and top !=0:
		c = c[bottom:top]
	if bottom!=0 and top != 0:
		c = c[bottom:top]
		
	wrapListings(c,dur)
##	  for i in c:
##		  channel = i
##		  name = channel.getName()
##		  print name
##		  for a in channel.getChannel():
##			  print "\t%s" % a
def getMax():
	list = readListing(0)
	return len(list)
	
def chooseLineup(lineup):
	pref = readPreferences()
	if pref != 0:
		pref.setLineup(lineup)
		writePreferences(pref)
	else:
		print "Preferences not created"
		
def getZip():
	pref = readPreferences()
	print pref.getZip()
	
if __name__ == "__main__":
	args = sys.argv
	ta = len(args)
	for i in range(len(args)):
		if args[i] == "--getlineup":
			print getLineup(args[i+1])
		if args[i] == "--setlineup":
			chooseLineup(args[i+1])
		if args[i] == "--getlisting":
			if ta >= 4:
				print getListing(int(args[i+1]),int(args[i+2]))
			else:
				getListing(int(args[i+1]));
		if args[i] == "--printlisting":
			
			if ta >= i+2:
				listing = readListing(int(args[i+3]))
				printListings(listing,int(args[i+1]),int(args[i+2]),int(args[i+3]))
			else :
				printListings(listing)
		if args[i] == "--max":
			print getMax()
		if args[i] == "--zip":
			getZip()
		if args[i] == "--find":
			num = findChannel(int(args[i+1]))
			if num != None:
				print num
			else:
				print -1
		if args[i] == "--createfav":
			createFavoritesList()
		if args[i] == "--maxchannels":
			pref = readPreferences()
			print pref.getNumOfChannels()
		if args[i] == "--setfav":
			setFavorite(args[i+1],args[i+2])
		if args[i] == "--clearfav":
			clearFavorites()
		if args[i] == "--allchannels":
			downloadAllChannels()
		if args[i] == "--country":
			pref = readPreferences()
			pref.setCountry(args[i+1])
			writePreferences(pref)
		if args[i] == "--createallfav":
			createAllFavoritesList()
		if args[i] == "--numoffav":
			numberOfFavorites()
	#main()
	
	